#include "stc32g.h"

#define FOSC            24000000UL

#define MCLK_HIRC       0
#define MCLK_IRC32K     1
#define MCLK_IRC48M     2
#define MCLK_XOSC       3
#define MCLK_X32K       4
#define MCLK_PLL        5
#define MCLK_PLLD2      6
#define MCLK_SEL        MCLK_PLL

#define PLL_96M         0
#define PLL_144M        1
#define PLL_SEL         PLL_144M

#define CKMS            0x80
#define HSIOCK          0x40
#define MCK2SEL_MSK     0x0c
#define MCK2SEL_SEL1    0x00
#define MCK2SEL_PLL     0x04
#define MCK2SEL_PLLD2   0x08
#define MCK2SEL_IRC48   0x0c
#define MCKSEL_MSK      0x03
#define MCKSEL_HIRC     0x00
#define MCKSEL_XOSC     0x01
#define MCKSEL_X32K     0x02
#define MCKSEL_IRC32K   0x03

#define ENCKM           0x80
#define PCKI_MSK        0x60
#define PCKI_D1         0x00
#define PCKI_D2         0x20
#define PCKI_D4         0x40
#define PCKI_D8         0x60

void delay()
{
    int i;
    
    for (i=0; i<100; i++);
}

void main()
{
    WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ
    EAXFR = 1; //չĴ(XFR)ʹ
    CKCON = 0; //߷XRAMٶ
    
    //ѡPLLʱ
#if (PLL_SEL == PLL_96M)
    CLKSEL &= ~CKMS;            //ѡPLL96MΪPLLʱ
#elif (PLL_SEL == PLL_144M)
    CLKSEL |= CKMS;             //ѡPLL144MΪPLLʱ
#else
    CLKSEL &= ~CKMS;            //ĬѡPLL96MΪPLLʱ
#endif
    
    //ѡPLLʱӷƵ,֤ʱΪ12M
    USBCLK &= ~PCKI_MSK;
#if (FOSC == 12000000UL)
    USBCLK |= PCKI_D1;          //PLLʱ1Ƶ
#elif (FOSC == 24000000UL)
    USBCLK |= PCKI_D2;          //PLLʱ2Ƶ
#elif (FOSC == 48000000UL)
    USBCLK |= PCKI_D4;          //PLLʱ4Ƶ
#elif (FOSC == 96000000UL)
    USBCLK |= PCKI_D8;          //PLLʱ8Ƶ
#else
    USBCLK |= PCKI_D1;          //ĬPLLʱ1Ƶ
#endif

    //PLL
    USBCLK |= ENCKM;            //ʹPLLƵ
    
    delay();                    //ȴPLLƵ

    CLKDIV = 8;                 //ʱѡƵǰ,÷Ƶϵ,ᵱ

    //ѡʱԴ
    CLKSEL &= ~MCKSEL_MSK;
    CLKSEL &= ~MCK2SEL_MSK;
#if (MCLK_SEL == MCLK_HIRC)
    CLKSEL |= MCKSEL_HIRC;      //ѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_SEL1;     //ѡMCKSELѡʱΪʱ
#elif (MCLK_SEL == MCLK_IRC32K)
    CLKSEL |= MCKSEL_X32K;      //ѡⲿ32KΪʱ
    CLKSEL |= MCK2SEL_SEL1;     //ѡMCKSELѡʱΪʱ
#elif (MCLK_SEL == MCLK_IRC48M)
    CLKSEL |= MCKSEL_HIRC;      //ѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_IRC48;    //ѡڲ48MIRCΪʱ
#elif (MCLK_SEL == MCLK_XOSC)
    CLKSEL |= MCKSEL_XOSC;      //ѡⲿپΪʱ
    CLKSEL |= MCK2SEL_SEL1;     //ѡMCKSELѡʱΪʱ
#elif (MCLK_SEL == MCLK_X32K)
    CLKSEL |= MCKSEL_IRC32K;    //ѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_SEL1;     //ѡMCKSELѡʱΪʱ
#elif (MCLK_SEL == MCLK_PLL)
    CLKSEL |= MCKSEL_HIRC;      //ѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_PLL;      //ѡPLLʱΪʱ
#elif (MCLK_SEL == MCLK_PLLD2)
    CLKSEL |= MCKSEL_HIRC;      //ѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_PLLD2;    //ѡPLLʱ2ƵʱΪʱ
#else
    CLKSEL |= MCKSEL_HIRC;      //ĬѡڲIRCΪʱ
    CLKSEL |= MCK2SEL_SEL1;     //ĬѡMCKSELѡʱΪʱ
#endif
    
//    P5M0 = 0x10;
//    P5M1 = 0x00;
//    MCLKOCR = 0x01;             //ϵͳʱ1ƵP5.4
    
    P1M0 = 0x40;
    P1M1 = 0x00;
    MCLKOCR = 0x81;             //ϵͳʱ1ƵP1.6
    
    while (1);
}
